{
  # Variables that can be overriden in the command line
  'variables': {
    'nomad%': 'false',
    'vexplib%': 'false',
    'vexp_includedir%': '',
    'vexp_libdir%': '-lvexplib',
  },  

  'targets': [
    {
      # Addon cameo nomad only compiled on linux
      'target_name': 'addoncameonomad',
      'sources': [
      ],
      'cflags': [ '-fno-exceptions' ],
      'cflags_cc': [ '-std=c++17' ],
      'conditions': [
        ['nomad=="true"', {
          'sources': [
            'addons/cameo-nomad-addon.cc',
          ],
          'libraries': [
            '-lzmq -lnomadaccessor -lcameo-api-cpp -lprotobuf -lzmq'
          ]
        }]
      ]
    },
    
    {
      # Addon vexp spy function only compiled on linux
      'target_name': 'addonvexpspy',
      'cflags': [ '-fno-exceptions' ],
      'cflags_cc': [ '-std=c++17' ],
      'conditions': [
        ['nomad=="true"', {
          'sources': [
            'addons/cameo-spy-addon.cc',
          ],
          'libraries': [
            '-lzmq -lcameo-api-cpp -lprotobuf -lzmq'
          ]
        }]
      ]
    },

    {
      # Addon vexplib compiled on linux, windows, mac
      'target_name': 'addonvexplib',
      'sources': [
      ],
      'cflags': [ '-fno-exceptions' ],
      'cflags_cc': [ '-std=c++17' ],
      'include_dirs': [ '<(vexp_includedir)' ],
 
      # Necessary configurations for integrating the static library on windows and have coherent settings 
      'configurations': {
        'Debug': {
          'msvs_settings': {
            'VCCLCompilerTool': {
              'RuntimeLibrary': '3'
            },
          },
        },
        'Release': {
          'msvs_settings': {
            'VCCLCompilerTool': {
              'RuntimeLibrary': '2'
            },
          },
        },
      },
  
      'conditions': [
        ['vexplib=="true"', {
          'sources': [
            'addons/vexplib-addon.cc',
          ],
          'conditions': [
            ['OS=="mac"', {
              'xcode_settings': {
                'GCC_ENABLE_CPP_EXCEPTIONS': 'YES'
              },
              'libraries': [ '-lvexplib' ]
            }],
            ['OS=="win"', {
              'libraries': [ '<(vexp_libdir)' ]
            }],
            ['OS=="linux"', {
              'libraries': [ '<(vexp_libdir)' ]
            }],
          ],
        }]
      ]
    }

  ]
}
