const THREE = require('three');
const fs  = require('fs');
const viewManager = require('../../utils/view-manager');
const default_config = require("../../../../resources/default-config");

class BzPanelView
{

    constructor(){

        this._takinPath = default_config["takin_bz"];
        this._takinPathValide = false;
        this._onlyAlphaOnFace = "";
        let html = `

        <div class='container' style='width:100%'>

    <div class='row  pb-2'></div>    


    <div class='row '>
        <label class='col-sm-12'>Takin Bz Path:</label>
    </div>
    <div class='row  pb-1'>
        <input type="text" class="form-control col-sm-12" id="takin_bz-inputBox"placeholder=`+this._takinPath+`>
    </div>

    <div id="takin_bz-path-collapse" class="panel-collapse collapse">

    <div class='row  pb-1'>
        <label class='col-sm-3'>Bz View Mode</label>
        <select class="col-sm-4  pb-1" id='bz-view-mode'  ></select>
    </div>
    <div id="default-bz-position" class="panel-collapse collapse">
        <div class='row  pb-1'>
            <label class='col-sm-3'>Default Position</label>
            <input type='text' class='col-sm-3 border-right-text-input' id='offset-position-x'/>
            <input type='text' class='col-sm-3 border-left-text-input border-right-text-input' id='offset-position-y'/>
            <input type='text' class='col-sm-3 border-left-text-input' id='offset-position-z'/>
        </div>
    </div>
    <div id="bz-view-collapse" class="panel-collapse collapse">
        <div class='row  pb-1'>
            <label class='col-sm-3'>Face Template</label>
            <select class="col-sm-4  pb-1" id='face-template'  ></select>
        </div>
        <div id="normal-face-color" class="panel-collapse collapse">
            <div class='row  pb-1'>
                <label class='col-sm-3'>Normal Perspective</label>
                <select class="col-sm-4  pb-1" id='normal-perspective' ></select>
            </div>
        </div>
        <div id="alpha-normal-collapse" class="panel-collapse collapse">
            <div class='row'>
                <div class='col-sm-3'>Face Alpha</div>
                <input type='text' class='col-sm-2' id='FAonly'/>
            </div>
        </div>
        

        <div id="unicolor-collapse" class="panel-collapse collapse">
            <div class='row'>
                <div class='col-sm-3'>Face Color RGBA</div>
                <input type='text' class='col-sm-2 border-right-text-input ' id='FR'/>
                <input type='text' class='col-sm-2 border-left-text-input border-right-text-input ' id='FG'/>
                <input type='text' class='col-sm-2 border-left-text-input border-right-text-input' id='FB'/>
                <input type='text' class='col-sm-2 border-left-text-input' id='FA'/>
            </div>
        </div>
        <div class='row  pb-1'></div>
        <div class='row  pb-1'>
            <label class='col-sm-3'>Show Edge</label>
            <input class="col-sm-1" type="checkbox" id="showEdge"> 
        </div>
        <div id="edge-color-collapse" class="panel-collapse collapse">
            <div class='row'>
                <div class='col-sm-3'>Edge Color RGBA</div>
                <input type='text' class='col-sm-2 border-right-text-input' id='ER'/>
                <input type='text' class='col-sm-2 border-left-text-input border-right-text-input' id='EG'/>
                <input type='text' class='col-sm-2 border-left-text-input border-right-text-input' id='EB'/>
                <input type='text' class='col-sm-2 border-left-text-input ' id='EA'/>
            </div>
        </div>
        </div>
        </div>
        </div>`;
        this.html = html;
        myLayout.registerComponent('Brillouin Zone', function(container, state) {
            container.getElement().html(html);
        });

        viewManager.addView(this);
        this.init( );

    }

    init()
    {

        $('#takin_bz-inputBox').keypress((event), () => { 
            if (event.which == 13 || event.keyCode == 13) {
                this._takinPath = $("#takin_bz-inputBox").val();
                this.checkTakinPathValide();
                $("#takin_bz-inputBox").val("");
                $("#takin_bz-inputBox").attr('placeholder', this._takinPath);
                PubSub.publish('update-path', this.getInputs());
            }
        });
        $("#bz-view-collapse").collapse("show");

        $("#FR, #FG, #FB, #FA, #ER, #EG, #EB, #EA").keypress((event) => {

            if (event.which == 13 || event.keyCode == 13) {
                PubSub.publish('update-bz-struc', this.getInputs());
            }
        });

        $("#offset-position-x, #offset-position-y, #offset-position-z").keypress((event) => {

            if (event.which == 13 || event.keyCode == 13) {
                PubSub.publish('update-bz-struc', this.getInputs());
            }
        });

        $("#FAonly").keypress((event) =>{
            if (event.which == 13 || event.keyCode == 13) {
                $("#FA").val($("#FAonly").val());
                PubSub.publish('update-bz-struc', this.getInputs());
            }
        })

        // Change bz view Mode
        $("#bz-view-mode").change(() => {
            PubSub.publish('update-bz-struc', this.getInputs());
        });
        $("#normal-perspective").change(() => {
            PubSub.publish('update-bz-struc', this.getInputs());
        });
        $("#face-template").change(() => {
            PubSub.publish('update-bz-struc', this.getInputs());
        });
        $('#showEdge').change((event) => {
            PubSub.publish('update-bz-struc', this.getInputs()); 
        });

        let bzView = ["single", "multiple", "hide"];
        for (let index = 0; index < bzView.length; index++) {
            $("#bz-view-mode").append($("<option/>").val(bzView[index]).html(bzView[index]));
        }
        
        $("#normal-perspective").append($("<option/>").val("relative").html("relative"));
        $("#normal-perspective").append($("<option/>").val("absolut").html("absolut"));

        let faceTemplate = ["unicolor", "normal", "hide"];
        for (let index = 0; index < faceTemplate.length; index++) {
            $("#face-template").append($("<option/>").val(faceTemplate[index]).html(faceTemplate[index]));
        }
        
        $("#FR").val(0);
        $("#FG").val(0);
        $("#FB").val(75);
        $("#FA").val(.15);
        $("#FAonly").val(.15);
        $("#ER").val(0);
        $("#EG").val(0);
        $("#EB").val(0);
        $("#EA").val(1);
        $("#offset-position-x").val(0);
        $("#offset-position-y").val(0);
        $("#offset-position-z").val(0);
        $("#takin_bz-path-texte").val(this._takinPath);
        this.checkTakinPathValide();
        this.refreshCollapse();


        PubSub.subscribe('change-offset-position', (msg, value) => {this.changeOffsetValue(value)});
        PubSub.publish('refresh-all-bz-view', this.getInputs());

    }

    /**
     * This function will write on bz value that have been verified / syncronized
     * @param {*} value 
     */
    setInput(value)
    {
        $("#offset-position-x").val(value.defaultPosition[0]);
        $("#offset-position-y").val(value.defaultPosition[1]);
        $("#offset-position-z").val(value.defaultPosition[2]);
        $("#FR").val(value.faceColor[0]);
        $("#FG").val(value.faceColor[1]);
        $("#FB").val(value.faceColor[2]);
        $("#FA").val(value.faceColor[3]);
        $("#FAonly").val(value.faceColor[3]);
        $("#ER").val(value.edgeColor[0]);
        $("#EG").val(value.edgeColor[1]);
        $("#EB").val(value.edgeColor[2]);
        $("#EA").val(value.edgeColor[3]);

        this.refreshCollapse();
    }
    
    /**
     * This function change position when shortcut is pressed
     * @param {[x,y,z]} position 
     */
    changeOffsetValue(position)
    {
        $("#offset-position-x").val(position[0]);
        $("#offset-position-y").val(position[1]);
        $("#offset-position-z").val(position[2]);
        PubSub.publish('update-bz-struc', this.getInputs());

    }
    /**
     * This function control UI
     */
    refreshCollapse()
        {
            if($("#bz-view-mode").val() == "single")
            {
                $("#default-bz-position").collapse("show");
            }else
            {
                $("#default-bz-position").collapse("hide");  
            }
                
            if($("#bz-view-mode").val() == "hide")
            {
                $("#bz-view-collapse").collapse("hide");
                
            }
            else
            {
                $("#bz-view-collapse").collapse("show");
            }
            if($("#face-template").val() == "unicolor")
            {
                $("#unicolor-collapse").collapse("show");
                $("#alpha-normal-collapse").collapse("hide");
                $("#normal-face-color").collapse("hide");
                
            }
            else if($("#face-template").val() == "normal")
            {
                $("#unicolor-collapse").collapse("hide");

                if($("#normal-perspective").val() == "relative")
                {
                    $("#alpha-normal-collapse").collapse("show");
                    $("#normal-face-color").collapse("show");

                }
                else
                {
                    $("#normal-face-color").collapse("show");
                    $("#alpha-normal-collapse").collapse("hide");

                }
            }
            else
            {
                $("#unicolor-collapse").collapse("hide");
                $("#normal-face-color").collapse("hide");
                $("#alpha-normal-collapse").collapse("hide");

            }
            if($("#showEdge").prop('checked'))
            {
                $("#edge-color-collapse").collapse("show");
            }
            else
            {
                $("#edge-color-collapse").collapse("hide");
            }
            
        }

    /**
     * This function detecte there are a file name takin_bz.exe on the folder path
     * @returns bool type
     */
    fileExiste(){
        try{
            return fs.statSync(this._takinPath).isFile();
        }
        catch(exception_var)
        {
            return false;
        }
    }
    
    /**
     * This function detecte and lock UI if takin path is incorrect
     */
    checkTakinPathValide()
    {
        let existe = this.fileExiste();

        if(existe)
        {
            $("#takin_bz-path-collapse").collapse("show");
            this._takinPathValide = true;
        }
        else
        {
            $("#takin_bz-path-collapse").collapse("hide");
            this._takinPathValide = false;
            console.log("can't find takin_bz at : " + this._takinPath);   
        }
    }

    /**
     * This function take UI data into a object
     * @returns a object with all UI data
     */
    getInputs()
    {
        this.refreshCollapse();
        return{
            bzViewMode: $("#bz-view-mode").val(),
            normalPerspective: $("#normal-perspective").val(),
            faceTemplate: $("#face-template").val(),
            showEdge: $("#showEdge").prop('checked'),
            faceColor:[$("#FR").val(), $("#FG").val() , $("#FB").val() , $("#FA").val()],
            edgeColor:[$("#ER").val(), $("#EG").val() , $("#EB").val() , $("#EA").val()],
            takinPath: this._takinPath,
            takinPathValide: this._takinPathValide,
            offsetPosition: [$("#offset-position-x").val(),$("#offset-position-y").val(), $("#offset-position-z").val()],
        }
    }

    /**
     * This function is never call ...
     * @returns 
     */
    changeTakinPath() {
        let inputs = { };

        // If a file is provided
        const files = $("#cif")[0].files;

        if (files.length > 0) {
            // Get the name of the file and not path that is only available with Electron.
            let file = files[0].name;
            if (file === null || file === "") {
                return;
            }

            inputs.filename = file;
            
            let reader = new FileReader();
            reader.readAsText(files[0], "UTF-8");

            reader.onload = (event) => {
                let dat = event.target.result;
                inputs.filedata = dat;

                // Publish the new inputs.
                PubSub.publish('import-cif', inputs);
            };
        }
    }


    render()
    {

    }



 
}
module.exports = BzPanelView;
