const fs = require('fs');
const path = require('path');
const homeDirectory = require('os').homedir();

let configPath = path.join(homeDirectory, '.vexp', 'config.json');

console.log('Reading config file : ' + configPath);

let config = {
    localEndpoint: "tcp://localhost:7000",
    nomadEndpoint: "tcp://localhost:7000"
}

// Read the file if it exists.
if (fs.existsSync(configPath)) {
    let readConfig = JSON.parse(fs.readFileSync(configPath, 'utf8'));

    config.localEndpoint = readConfig.localEndpoint;
    config.nomadEndpoint = readConfig.nomadEndpoint;
}

console.log('Local endpoint : ' + config.localEndpoint);
console.log('Nomad endpoint : ' + config.nomadEndpoint);

module.exports = config;
